/*-*-c++-*-
 *
 *     Project: xfdtoatr
 * Description: Kopiert eine xfd Datei zu einer atr Datei
 *              Funktioniert nur mit 256 * 720 Disks!!!
 *
 *   Author(s): Lars Langhans
 *   Copyright: (c)2014 by Lars Langhans
 */

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/stat.h>
#include <unistd.h>

using namespace std; 

    int DISK_DENSITY = 256;

    int sektorOffset(int sector) {
        int offset;
        int density = DISK_DENSITY;

        offset = sector * density;

        return offset;
    }

    



    int main(int argc, const char *argv[]) {
        
        // cout << sektorOffset(720) << endl;

        const char *inp_filename;
        inp_filename = argv[1];
        if (inp_filename == NULL) {
            cerr << "Kein input file angegeben" << endl;
            exit(1);
        }
        
        const char *out_filename;
        out_filename = argv[2];
        if (out_filename == NULL) {
            cerr << "Kein output file angegeben" << endl;
            exit(1);
        }

        FILE *in = fopen(inp_filename, "r");
        if (!in) {
            cerr << "no inputfile" << endl;
            exit(2);
        }

        unsigned char buffer[256];
        // check if we are not already atr
        fread(buffer, 16, 1, in);
        if (buffer[0] == 0x96 &&
            buffer[1] == 0x02 &&
            buffer[2] == 0x00 &&
            buffer[3] == 0x2d) {
            cerr << "ATR Header erkannt" << endl;

            fclose(in);
            exit(3);
        }
        fseek(in, 0,0);
        
        struct stat buf;
        stat(inp_filename, &buf);
        // cout << buf.st_size << endl;

        if (buf.st_size != sektorOffset(720)) {
            cerr << "momentan nur double density 720 Sektoren a 256 Bytes!" << endl;
            exit(1);
       }
        
 
        FILE *out = fopen(out_filename, "w");
        if (!out) {
            cerr << "no outputfile" << endl;
            exit(2);
        }
        
        // create atr buffer
        unsigned char atr[16];
        for (int i=0;i<16;i++) {
            atr[i] = 0;
        }
        
        atr[0] = 0x96;
        atr[1] = 0x02;
        atr[2] = 0x00;
        atr[3] = 0x2d;
        atr[4] = 0x00;
        atr[5] = 0x01;
        atr[6] = 0x00;
        atr[7] = 0x00;

        // write atr buffer
        fwrite(atr, 16, 1, out);

        // copy file        
        int count = 0;
        while(!feof(in)) {
            size_t n = fread(buffer, 256, 1, in);
            if (n != 0) {    
                fwrite(buffer, 256, 1, out);
            }
        }
        fclose(in);
        fclose(out);
     }

